--[[
    Author: Atrophenus
    Version: 1.0
    Description: Automates input of chat commands to set binds (etc...) on usage of command
    
    DISCLAIMER: DUE TO THE TECHNICAL NATURE OF THIS PLUGIN YOU CAN CAUSE SERIOUS ISSUES WITH YOUR BINDS OR ANYTHING ELSE YOU
                TRY TO HAVE THIS PLUGIN DO IF USED INCORRECTLY USE AT YOUR OWN RISK

    Set Up: 
    In order to setup the plugin you will need to head to https://www.vendetta-online.com/manual/app_commands.html to get all the commands
    you wish to rebind when ever you run this plugin. From there you will need to manually type into AutoBindCommands table the commands you
    would like for this plugin to run. Under FORMAT is how to input a command for this program to run and an example under that. DO NOT
    PUT THE / AT THE BEGINNING OF YOUR ENTRY.
    Once saved simply type "/autobind" into the chat window in game to set your binds.

    FORMAT: 'command keybind data';
    EXAMPLE: 'alias mt "+turbo 0"';
             'bind t mt'

    In the table below is some preset binds to help with understanding formatting
]]

--DO NOT TOUCH
AutoBind = {}
AutoBindFunc = {}

-- Enter the chat commands you would like run when /autobind is used
AutoBindCommands = {
    'bind T Say_Channel';
    'bind G Say_Group';
    'bind X Say_Guild';
    'bind Z Say_Sector';
    'bind r +Accelerate';
    'bind f +Decelerate';
    'bind w +StrafeUp';
    'bind s +StrafeDown';
    'bind | consoletoggle';
}

-- Tablelength function to deterimine how long to run the for loop for
function AutoBindFunc.tablelength(table)
    local count = 0
    for _ in pairs(table) do count = count + 1 end
    return count
  end

-- Actual autobind function prints a message if table is empty otherwise runs the entered chat commands in the table
function AutoBind.autobind()
    local entries = AutoBindFunc.tablelength(AutoBindCommands)
    if entries == 0 then
        print('\127ffffff AutoBind commands table empty. Please add commands to make use of autobind.')
    else
        for i = 1, entries do 
        gkinterface.GKProcessCommand(AutoBindCommands[i])
        end
        print('Autobind done')
    end
end

RegisterUserCommand('autobind', AutoBind.autobind)